package Security::fs;

use Security::find;
use Filesys::Statvfs;
use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() );

sub init {
	&Security::find::add_wanted (\&fs_wanted);
	&main::read_config('ignorefs');
}

# Check for files that have no defined owner or group.
# From HP-UX System Security manual
sub fs_wanted {
	if ( ! -l $File::Find::name && -d $File::Find::name ) {

		my($bsize, $frsize, $blocks, $bfree, $bavail,
			$files, $ffree, $favail, $fsid, $basetype, $flag,
			$namemax, $fstr)=statvfs($File::Find::name);

		# Linux does not support the basetype in their statvfs system call!
		printf STDERR "Could not find basetype for $File::Find::name" 
			if (  $^O ne 'linux' && !defined $basetype && $main::opts{'d'} );

		for (my ($i) = 0; $i <= $#main::ignorefs; $i++) {
			if ( defined $basetype && $basetype eq $main::ignorefs[$i] ) {
				$File::Find::prune = 1;
				printf STDERR "\tPruning Tree at $File::Find::name ($basetype)\n" 
					if ( $main::opts{'d'} );
			}
		}
	}
}

1;
