package Security::library;

use Security::find;
use Exporter;
use POSIX;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &print() );

our (%libraryperms);

sub init {
	print ( STDERR  "In Security::library::init()\n") if ( $main::opts{'d'} );

	&main::read_config('sharedregex');
	&Security::find::add_wanted (\&library_wanted);
}

# Added shared library file checks based on the SANS98 Conference
sub library_wanted {
	if ( ! -l $File::Find::name && -f $File::Find::name ) {
		if ( $File::Find::name =~ /\/${main::sharedregex[0]}$/ ) {

			my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$curbytes) = 
				&Security::find::get_stat($File::Find::name, 'lstat');

			if ( defined $Security::db::db ) {
				$Security::db::db{$File::Find::name} =
					&main::SHA1($File::Find::name);
			}

			# If the file is world writeable, then flag this case too
			$libraryperms{$File::Find::name} = 1
				if ( $mode & &S_IWOTH() );
		}
	}
}

sub print {
	print ( STDERR  "In Security::library::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for world writable shared libraries:\n", %libraryperms);
}

1;
